/*
===============================================================================

	FILE:	material.cpp
	
	CONTENTS:
	
    see corresponding header file
	
	PROGRAMMERS:
	
		martin isenburg@cs.unc.edu
	
	COPYRIGHT:
	
		Copyright (C) 2000  Martin Isenburg (isenburg@cs.unc.edu)
		
		This software is distributed in the hope that it will be useful,
		but WITHOUT ANY WARRANTY; without even the implied warranty of
		MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
	
	CHANGE HISTORY:
	
    see corresponding header file
	
===============================================================================
*/
#include "material.h"

#include <string.h>

CFmaterial::CFmaterial()
{
  a[0] = 0.3f; d[0] = 0.6f; s[0] = 0.5f; e[0] = 0.0f;
  a[1] = 0.3f; d[1] = 0.6f; s[1] = 0.5f; e[1] = 0.0f;
  a[2] = 0.3f; d[2] = 0.6f; s[2] = 0.5f; e[2] = 0.0f;
  a[3] = 1.0f; d[3] = 1.0f; s[3] = 1.0f; e[3] = 1.0f;
  sn = 10.0f;
  strncpy(name, "no name", 128);
}

CFmaterial::CFmaterial(char* n)
{
  a[0] = 0.3f; d[0] = 0.6f; s[0] = 0.5f; e[0] = 0.0f;
  a[1] = 0.3f; d[1] = 0.6f; s[1] = 0.5f; e[1] = 0.0f;
  a[2] = 0.3f; d[2] = 0.6f; s[2] = 0.5f; e[2] = 0.0f;
  a[3] = 1.0f; d[3] = 1.0f; s[3] = 1.0f; e[3] = 1.0f;
  sn = 10.0f;
  strncpy(name, n, 128);
}

CFmaterial::CFmaterial(char* n, float r, float g, float b)
{
  a[0] = 0.3f*r; d[0] = 0.6f*r; s[0] = 0.5f; e[0] = 0.0f;
  a[1] = 0.3f*g; d[1] = 0.6f*g; s[1] = 0.5f; e[1] = 0.0f;
  a[2] = 0.3f*b; d[2] = 0.6f*b; s[2] = 0.5f; e[2] = 0.0f;
  a[3] = 1.0f; d[3] = 1.0f; s[3] = 1.0f; e[3] = 1.0f;
  sn = 10.0f;
  strncpy(name, n, 128);
}

CFmaterial::~CFmaterial()
{
}
