/*
===============================================================================

	FILE:	spinedge.cpp
	
	CONTENTS:
	
    see corresponding header file
	
	PROGRAMMERS:
	
		martin isenburg@cs.unc.edu
	
	COPYRIGHT:
	
		Copyright (C) 2000  Martin Isenburg (isenburg@cs.unc.edu)
		
		This software is distributed in the hope that it will be useful,
		but WITHOUT ANY WARRANTY; without even the implied warranty of
		MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
	
	CHANGE HISTORY:
	
    see corresponding header file
	
===============================================================================
*/
#include "spinedge.h"

CFspinEdge::CFspinEdge()
{
  group = 0;
  material = 0;
  component = 0;

  marker = 0;
  
  vertex = 0;
  normal = 0;
  next = 0;
  inv  = 0;
	spin = 0;

	Lnext = 0;

	is_on_boundary = 0;
}

CFspinEdge::CFspinEdge(int g, int m)
{
  group = g;
  material = m;
  component = 0;

  marker = 0;

  vertex = 0;
  normal = 0;
  next = 0;
  inv  = 0;
  spin = 0;

	Lnext = 0;

	is_on_boundary = 0;
}

CFspinEdge::CFspinEdge(int g, int m, CFvertex* v)
{
  group = g;
  material = m;
  component = 0;

  marker = 0;

  vertex = v;
  normal = 0;
  next = 0;
  inv  = 0;
  spin = 0;

	Lnext = 0;

	is_on_boundary = 0;
}

CFspinEdge::CFspinEdge(int g, int m, CFvertex* v, CFnormal* n)
{
  group = g;
  material = m;
  component = 0;

  marker = 0;

  vertex = v;
  normal = n;
  next = 0;
  inv  = 0;
  spin = 0;

	Lnext = 0;

	is_on_boundary = 0;
}

CFspinEdge::~CFspinEdge()
{
}
