/*
===============================================================================

	FILE:	vector.cpp
	
	CONTENTS:
	
    see corresponding header file
	
	PROGRAMMERS:
	
		martin isenburg@cs.unc.edu
	
	COPYRIGHT:
	
		Copyright (C) 2000  Martin Isenburg (isenburg@cs.unc.edu)
		
		This software is distributed in the hope that it will be useful,
		but WITHOUT ANY WARRANTY; without even the implied warranty of
		MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
	
	CHANGE HISTORY:
	
    see corresponding header file
	
===============================================================================
*/
#include "vector.h"

#include <iostream.h>

CFvector::CFvector()
{
  current_size = 0;
  current_capacity = 1000;
  data = (void**) new int[1000];
}

CFvector::~CFvector()
{
  delete [] data;
}

int CFvector::isEmpty()
{
  if (current_size == 0)
    {
      return 1;
    }
  else
    {
      return 0;
    }
}

void CFvector::ensureCapacity(int c)
{
  if (current_capacity < c)
    {
      void** temp = (void**) new int[c];
      for (int i = 0; i < current_size; i++)
	{
	  temp[i] = data[i];
	}
      current_capacity = c;
      delete [] data;
      data = temp;
    }
}

int CFvector::size() const
{
  return current_size;
}

void CFvector::setSize(int s)
{
  ensureCapacity(s);
  current_size = s;
}

void* CFvector::elementAt(int p) const
{
  if ((p < 0) || (p >= current_size))
    {
      return 0;
    }
  else
    {
      return data[p];
    }
}

void* CFvector::lastElement()
{
  if (current_size == 0)
    {
      return 0;
    }
  else
    {
      return data[current_size-1];
    }
}

void CFvector::addElement(void* e)
{
  checkCapacity();
  data[current_size] = e;
  current_size++;
}

void CFvector::setElementAt(void* e, int p)
{
  if ((p < 0) || (p >= current_size))
    {
      cerr << "ERROR in CFvector::setElementAt" << endl;
    }
  else
    {
      data[p] = e;
    }
}

void CFvector::removeElement(void* e)
{
  int p = -1;
  for (int i = current_size-1; i >= 0; i--)
    {
      if (e == data[i])
	{
	  p = i;
	  break;
	}
    }
  
  if (p == -1)
  {
    return;
  }
  
  for (i = p; i < current_size-1; i++)
    {
      data[i] = data[i+1];
    }
  current_size--;
}

void CFvector::removeElementAt(int p)
{
  if ((p < 0) || (p >= current_size))
    {
      return;
  }
  
  for (int i = p; i < current_size-1; i++)
    {
      data[i] = data[i+1];
    }
  current_size--;
}

void CFvector::removeLastElement()
{
  if (current_size > 0)
    {
      current_size--;
    }
}

void CFvector::removeAllElements()
{
  current_size = 0;
}

void CFvector::checkCapacity()
{
  if (current_capacity == current_size)
    {
      ensureCapacity(current_capacity*2);
    }
}
