/*
===============================================================================

	FILE:	vector.h
	
	CONTENTS:
	
		Cell Fixer
	
	PROGRAMMERS:
	
		martin isenburg@cs.unc.edu
	
	COPYRIGHT:
	
		Copyright (C) 2000  Martin Isenburg (isenburg@cs.unc.edu)
		
		This software is distributed in the hope that it will be useful,
		but WITHOUT ANY WARRANTY; without even the implied warranty of
		MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
	
	CHANGE HISTORY:
	
		20 May 2000 -- created
	
===============================================================================
*/
#ifndef CF_VECTOR_H
#define CF_VECTOR_H

class CFvector
{
public:
  CFvector();
  ~CFvector();

  int isEmpty();
  
  void ensureCapacity(int);
  
  int size() const;
  void setSize(int s);
  
  void* elementAt(int) const;
  void* lastElement();
  
  void addElement(void*);
  void setElementAt(void*, int);
  
  void removeElement(void*);
  void removeElementAt(int);
  void removeLastElement();
  void removeAllElements();

  // should be private
  
  void** data;
  int current_capacity;
  int current_size;
  
  void checkCapacity();
};

#endif
